# FIXME - tools/boottool should be packaged seperately as
# perl-Linux-Bootloader
## filter_from_requires |client/tools/boottool$|d
%{?filter_setup:
%filter_requires_in %{_datadir}/autotest/client/tools/boottool$
%filter_setup
}

Name: autotest
Version: 0.12.0
Release: 5%{?dist}
Summary: Framework for fully automated testing
Group: Applications
License: GPLv2 and BSD and LGPLv2.1+
# All content is GPLv2 unless otherwise stated.
# Part of frontend/afe/feeds/feed.py is BSD licensed code from Django
# frontend/afe/json_rpc is a heavily modified fork of the dead
# http://json-rpc.org/wiki/python-json-rpc which is LGPLv2.1+
URL: http://autotest.kernel.org/
BuildArch: noarch
# Use a tarball without the tests
Source0: http://test.kernel.org/releases/%{version}/%{name}-notests-%{version}.tar.bz2
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Patch1: 0001-Use-system-gwt-install.patch
Patch2: 0002-Use-the-system-simplejson-instead-of-the-bundled-one.patch
Patch3: 0003-Adjust-apache-config-paths-for-a-Red-Hat-Fedora-styl.patch
Patch4: 0004-Change-usr-local-autotest-to-usr-share-autotest.patch
Patch5: 0005-Background-scheduler-babysitter.patch
Patch6: 0006-Add-a-readme-for-deployment-on-Fedora.patch
Patch7: 0007-Add-a-RH-style-init-script-for-autotest.patch
#Patch8: 0008-Set-file-permissions-appropriately.patch
Patch9: 0008-Harness-standalone-Make-autotest-play-nice-with-syst.patch

# FIXME - the old client package was a subpackage
Obsoletes: %{name}-client

Requires: python >= 2.4
BuildRequires: python >= 2.4
BuildRequires: gwt-devel
BuildRequires: java-openjdk
BuildRequires: git-core
# Packages needed during %post and %pre processing
Requires(post): openssh
Requires(pre): shadow-utils
# Ensure scp, rsync and sshd are available
Requires: openssh-clients
Requires: openssh-server
Requires: rsync


%description
Autotest is a framework for fully automated testing. It is designed primarily
to test the Linux kernel, though it is useful for many other functions such as
qualifying new hardware. It's an open-source project under the GPL and is used
and developed by a number of organizations, including Google, IBM, and many 
others.

The autotest package provides the client harness capable of running autotest
jobs on a single system.


%package server
Summary: Server test harness and front-end for autotest
Group: Applications
Requires: %{name} = %{version}-%{release}
Requires: httpd mod_python MySQL-python gnuplot python-crypto python-paramiko
Requires: numpy python-matplotlib python-imaging
Requires: python-simplejson
Requires(post): chkconfig
Requires(post): initscripts
%if 0%{?fedora} >= 10
Requires(post): policycoreutils-python
%else
Requires(post): policycoreutils
%endif
#FIXME - Django-1.0.4 is needed by autotest :(
Requires: Django = 1.0.4


%description server
Autotest is a framework for fully automated testing. It is designed primarily
to test the Linux kernel, though it is useful for many other functions such as
qualifying new hardware. It's an open-source project under the GPL and is used
and developed by a number of organizations, including Google, IBM, and many 
others.

The autotest-server package provides the server harness capable of running
autotest jobs on a single system.


%prep
%setup -q -n %{name}-notests-%{version}

# Use git to apply patches, so that permission changes work
git init
# Setup a committer 
if [ -z "$GIT_COMMITTER_NAME" ]; then
    git config user.email "test@lists.fedoraproject.org"
    git config user.name "Fedora Quality Assurance"
fi
git add .
git commit -a -q -m 'Initial commit for %{version}'
# The below works in Fedora, but not yet in EL5
#git am -p1 %{patches}
# EL 5 version, stolen from Xorg, hold your nose
git am -p1 $(awk '/^Patch.*:/ { print "%{_sourcedir}/"$2 }' %{_specdir}/%{name}.spec)


%build
python utils/compile_gwt_clients.py -a


%install
rm -rf %{buildroot}
# Top level dir
install -d %{buildroot}%{_datadir}/autotest
# Top level files
install -p -m 0644 -t %{buildroot}%{_datadir}/autotest common.py \
global_config.ini shadow_config.ini 

# apache
# We only want the www dir and the configs go elsewhere
install -d %{buildroot}%{_datadir}/autotest/apache/www
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d
install -d %{buildroot}%{_sysconfdir}/httpd/autotest.d
# We want all of apache configs (except for legacy apache-conf) so just use 
# cp -a since install sucks.
cp -a apache/conf/* %{buildroot}%{_sysconfdir}/httpd/autotest.d
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/apache-conf
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/site-directives
rm %{buildroot}%{_sysconfdir}/httpd/autotest.d/all-directives
cp -a apache/apache-conf %{buildroot}%{_sysconfdir}/httpd/conf.d/autotest.conf

# cli
install -d %{buildroot}%{_datadir}/autotest/cli
cp -a cli/* %{buildroot}%{_datadir}/autotest/cli/

# database
install -d %{buildroot}%{_datadir}/autotest/database
cp -a database/* %{buildroot}%{_datadir}/autotest/database/

# client
install -d %{buildroot}%{_datadir}/autotest/client
cp -a client/* %{buildroot}%{_datadir}/autotest/client/

# frontend
install -d %{buildroot}%{_datadir}/autotest/frontend/{afe,client,migrations,templates}
install -d %{buildroot}%{_datadir}/autotest/frontend/afe/{doctests,feeds,fixtures,json_rpc,templates}
install -d %{buildroot}%{_datadir}/autotest/frontend/afe/templates/{admin, feeds}
install -d %{buildroot}%{_datadir}/autotest/frontend/client/www/{autotest.AfeClient,autotest.TkoClient}
install -d %{buildroot}%{_datadir}/autotest/frontend/templates/admin/afe/test
# Grab top level files in frontend,afe ; omit simplejson
find frontend/ -maxdepth 1 -type f -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/frontend/ \;
find frontend/afe/ -maxdepth 1 -type f \! -name "site_rpc_interface.py" -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/frontend/afe/ \;
# Grab everything in frontend/afe/doctests
cp -a frontend/afe/doctests/* %{buildroot}%{_datadir}/autotest/frontend/afe/doctests/
# Grab everything in frontend/afe/feeds
cp -a frontend/afe/feeds/* %{buildroot}%{_datadir}/autotest/frontend/afe/feeds/
# Grab everything in frontend/afe/fixtures
cp -a frontend/afe/fixtures/* %{buildroot}%{_datadir}/autotest/frontend/afe/fixtures/
# Grab everything in frontend/afe/json_rpc
cp -a frontend/afe/json_rpc/* %{buildroot}%{_datadir}/autotest/frontend/afe/json_rpc/
# Grab everything in frontend/afe/templates
cp -a frontend/afe/templates/* %{buildroot}%{_datadir}/autotest/frontend/afe/templates/
# Grab everything in frontend/client/www
cp -a frontend/client/www %{buildroot}%{_datadir}/autotest/frontend/client/
# Grab everything in frontend/migrations
cp -a frontend/migrations/* %{buildroot}%{_datadir}/autotest/frontend/migrations/
# Grab everything in frontend/templates
cp -a frontend/templates/* %{buildroot}%{_datadir}/autotest/frontend/templates/
# Grab everything in frontend/test
cp -a frontend/templates/admin/afe/test/* %{buildroot}%{_datadir}/autotest/frontend/templates/admin/afe/test/

# logs
install -d %{buildroot}%{_datadir}/autotest/logs
cp -a logs/* %{buildroot}%{_datadir}/autotest/logs/

# mirror
install -d %{buildroot}%{_datadir}/autotest/mirror
cp -a mirror/* %{buildroot}%{_datadir}/autotest/mirror/

# new_tko
install -d %{buildroot}%{_datadir}/autotest/new_tko
cp -a new_tko/* %{buildroot}%{_datadir}/autotest/new_tko/

# packages
install -d %{buildroot}%{_datadir}/autotest/packages
cp -a packages/* %{buildroot}%{_datadir}/autotest/packages/

# results
install -d %{buildroot}%{_datadir}/autotest/results
cp -a results/* %{buildroot}%{_datadir}/autotest/results/

# scheduler
install -d %{buildroot}%{_datadir}/autotest/scheduler
cp -a scheduler/* %{buildroot}%{_datadir}/autotest/scheduler/
chmod +x %{buildroot}%{_datadir}/autotest/scheduler/monitor_db_babysitter

# conmux - Only the directory is required.  Conmux is provided by the 'conmux' package.
install -d %{buildroot}%{_datadir}/autotest/conmux

# server - omit self-test, tests, and samples
install -d %{buildroot}%{_datadir}/autotest/server/{control_segments,hosts,tmp}
find server/ -maxdepth 1 -type f -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/server/ \;
cp -a server/control_segments/* %{buildroot}%{_datadir}/autotest/server/control_segments/
cp -a server/hosts/* %{buildroot}%{_datadir}/autotest/server/hosts/

# tko
install -d %{buildroot}%{_datadir}/autotest/tko/
cp -a tko/* %{buildroot}%{_datadir}/autotest/tko/

# utils
install -d %{buildroot}%{_datadir}/autotest/utils
# Package up everything but the unittest stuff and named_semaphore
find utils/ -maxdepth 1 -type f \! -name 'unittest_suite.py' -exec cp -a '{}' %{buildroot}%{_datadir}/autotest/utils/ \;
# Install RH style init script
install -d %{buildroot}%{_sysconfdir}/rc.d/init.d
cp -a utils/autotest.fedora %{buildroot}%{_sysconfdir}/rc.d/init.d/autotestd
rm %{buildroot}%{_datadir}/autotest/utils/autotest.fedora

# Make symlink for cli tool(s)
install -d %{buildroot}%{_bindir}
ln -s %{_datadir}/autotest/cli/atest %{buildroot}%{_bindir}/
install -d %{buildroot}%{_sbindir}
ln -s %{_datadir}/autotest/scheduler/monitor_db_babysitter %{buildroot}%{_sbindir}/

# Make a dir for the autotest user ssh stuff
install -d %{buildroot}%{_datadir}/autotest/.ssh
# touch ssh files for ghosting
touch %{buildroot}%{_datadir}/autotest/.ssh/id_rsa
touch %{buildroot}%{_datadir}/autotest/.ssh/id_rsa.pub

# Remove files we don't need
find %{buildroot}%{_datadir}/autotest/ -name "*_unittest.py" -exec rm '{}' \;
find %{buildroot}%{_datadir}/autotest/ -name "*_test.py" -exec rm '{}' \;


%clean
rm -rf %{buildroot}


%pre
getent group autotest >/dev/null || groupadd -r autotest
getent passwd autotest >/dev/null || \
useradd -r -g autotest -d %{_datadir}/autotest -s /bin/bash \
-c "User account for the autotest harness" autotest
exit 0


%post
if [ $1 -eq 1 ] ; then
su -c "ssh-keygen -q -t rsa -N '' -f %{_datadir}/autotest/.ssh/id_rsa" - autotest || exit 0
fi


%post server
semanage fcontext -a -t bin_t '%{_datadir}/autotest/tko(/.*cgi)?'
restorecon %{_datadir}/autotest/tko/*
/sbin/chkconfig --add autotestd


%preun server
if [ $1 -eq 0 ]; then
    /sbin/service autotestd stop >/dev/null 2>&1
    /sbin/chkconfig --del autotestd
fi


%files
%defattr(-,autotest,autotest,-)
%doc %attr(-,root,root) DCO LICENSE CODING_STYLE README.fedora Documentation/*
%doc /usr/share/autotest/client/bin/self-test/README
%doc /usr/share/autotest/client/common_lib/README
%doc /usr/share/autotest/client/profilers/powertop/src/README
%dir %{_datadir}/autotest
%{_datadir}/autotest/client


%files server
%defattr(-,autotest,autotest,-)
%doc /usr/share/autotest/logs/README
%doc /usr/share/autotest/packages/README
%doc /usr/share/autotest/results/README
# The top level dir in /usr/share is owned by client
%dir %{_datadir}/autotest/.ssh
%dir %{_sysconfdir}/httpd/autotest.d
%ghost %{_datadir}/autotest/.ssh/*
%{_datadir}/autotest/apache
%{_datadir}/autotest/cli
%{_datadir}/autotest/conmux
%{_datadir}/autotest/database
%{_datadir}/autotest/frontend
%{_datadir}/autotest/logs
%{_datadir}/autotest/mirror
%{_datadir}/autotest/new_tko
%{_datadir}/autotest/packages
%{_datadir}/autotest/results
%{_datadir}/autotest/scheduler
%{_datadir}/autotest/server
%{_datadir}/autotest/tko
%{_datadir}/autotest/utils
%{_datadir}/autotest/common.py*
%{_bindir}/atest
%{_sbindir}/monitor_db_babysitter
%{_sysconfdir}/rc.d/init.d/autotestd
%config(noreplace) %{_datadir}/autotest/global_config.ini
%config(noreplace) %{_datadir}/autotest/shadow_config.ini
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/httpd/autotest.d/*
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/httpd/conf.d/autotest.conf


%changelog
* Tue Jul 12 2011 James Laska <jlaska@redhat.com> - 0.12.0-5
- Adjust git dependency for RHEL6 builds

* Wed Apr 13 2011 James Laska <jlaska@redhat.com> - 0.12.0-4
- Add filter_requires_in for boottool (perl-Linux-Bootloader)
- Patch for proper systemd support (changeset 5300)

* Tue Jan 25 2011 James Laska <jlaska@redhat.com> - 0.12.0-3
- Add %requires for rsync, openssh-{clients,server}
- Add BuildRequires on python

* Thu Jan 20 2011 James Laska <jlaska@redhat.com> - 0.12.0-2
- Change %requires to java-openjdk

* Tue Jun 22 2010 James Laska <jlaska@redhat.com> - 0.12.0-1
- New upstream release autotest-0.12.0
- Updated patchset
- Combine autotest and autotest-client
- Rename initscript to autotestd
- Add conmux directory, required even if conmux isn't used

* Thu Nov 19 2009 James Laska <jlaska@redhat.com> - 0.11.0-4
- Updated Patch4 (0004-Change-usr-local-to-usr-share.patch) so that
  global_config.ini also uses /usr/share/autotest

* Fri Nov 13 2009 James Laska <jlaska@redhat.com> - 0.11.0-3
- Moved autotest user creation into autotest-client package

* Tue Oct 30 2009 James Laska <jlaska@redhat.com> - 0.11.0-2
- Updated patch2 - new_tko/tko/graphing.py uses simplejson also
- Updated patch3 - correct http log paths
- Updated patch5 - background patch to work against monitor_db_babysitter
- Updated patch7 - RH style initscript updated to use monitor_db_babysitter
- Add patch9 to correct new_tko models.py issue with older django 

* Tue Aug 25 2009 Jesse Keating <jkeating@redhat.com> - 0.11.0-1
- Update for 0.11
- Drop unneeded patches
- Re-order patches with new upstream code set

* Fri Jul 31 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-8
- Fix AFE loading with the missing site_rpc_interface

* Tue Jul 14 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-7
- Remove the all-directives file, it is now redundant

* Wed Jul 08 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-6
- Move apache config files into /etc/
- Drop some unneeded files
- Set permissions accordingly
- Remove unneeded #! and add a missing one

* Tue Jul 07 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-5
- Make README.fedora a patch to the source code
- Make initscript a patch to the source code
- re-work background patch to be git compliant
- Remove macros for install
- Drop release level requirement on autotest-client.  Version is good enough

* Mon Jun 29 2009 James Laska <jlaska@redhat.com> - 0.10.0-4
- Add README.fedora
- Add autotest initscript
- Make scheduler/monitor_db.py executable

* Sat Jun 27 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-3
- Move ssh key into autotest home .ssh/ and name it generically
- Ghost the ssh dir
- More selinux fixes

* Fri Jun 26 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-2
- Patch path issues
- Set a shell for the autotest user to allow running init script
- Fix ssh key generation to run as autotest user
- SELinux fixes

* Tue Jun 16 2009 Jesse Keating <jkeating@redhat.com> - 0.10.0-1
- Initial attempt at packaging, adding to start from Lucas Meneghel Rodrigues
  <lmr@redhat.com>

